<template lang="pug">
    #app
        transition(name="fade", mode="out-in")
            .col-lg-6.col-xl-4.col-md-6.mx-auto.my-5(v-if="!loading")
                mdb-card
                    mdb-card-header.position-relative
                        .row.mt-4
                            .col-8
                                h2.text-primary.m-0 {{ nowDay }}
                            .col-4.d-flex.align-items-end.justify-content-end
                                span.text-black-50 {{ todos.length + " Tasks" }}
                        .row.mt-2
                            .col-8 
                                p.text-black-50 {{ nowMonth }}
                        mdb-btn.roundbutton(color="danger" @click="openEditModal()") +
                    mdb-card-body.p-0
                        .mt-5
                            .row.mx-0.taskrow.border-bottom.border-light(v-if="todos.length > 0" v-for="(todo, index) in todos" :key="index")
                                .col-auto.d-flex.align-items-center.justify-content-center.py-3
                                    input(type="checkbox" color="danger" v-model="todo.done" @change="saveTask(todo)")
                                .col-8.col-lg-8.d-flex.align-items-center.py-3(@click="openEditModal(todo.id)")
                                    span(:class="[todo.done ? 'inactive inactivecolor' : '']") {{ todo.title }}
                                .col-auto.d-flex.align-items-center.py-3(@click="openEditModal(todo.id)")
                                    span(:class="[todo.done ? 'inactivecolor' : '']") {{ timeFormat(todo.time) }}
                            .row.px-4(v-if="todos.length === 0")
                                .col
                                    p.emptylist.text-black-50 Add a task with the plus button...
        editmodal(:show="showEditModal" 
                    @editModalClosed="showEditModal = false" 
                    :taskToEdit="taskToEdit"
                    @create="createTask"
                    @save="saveTask"
                    @delete="deleteTask"
                    @cancel="cancel")
</template>

<script>

import moment from 'moment'
import editmodal from './modals/EditModal'
import _ from 'lodash'

export default {
    components: {editmodal},
    data() {
        return {
            todos: [],
            showEditModal: false,
            loading: true,
            taskToEdit: {}
        }
    },
    computed: {
        nowDay () {
            return moment().format("dddd, Do")
        },
        nowMonth () {
            return moment().format("MMMM")
        }
    },
    methods: {
        getTodos () {
            axios.get('api/todos').then(resp => {
                this.todos = resp.data
                this.loading = false
            }).catch(er => {
                alert("Sorry, something went wrong!")
                console.log(er)
            })
        },
        timeFormat (time) {
            return moment(time).format("HH:mm")
        },
        createTask (task) {
            if (task.title !== "" && task.time !== "") {
                axios.post("api/todos", task).then(resp => {
                    this.showEditModal = false
                    this.todos.push(resp.data)
                }).catch(er => {
                    alert("Sorry, something went wrong!")
                    console.log(er)
                })
            } else {
                alert("Please fill out the required fields")
            }
        },
        saveTask (task) {
            if (task.title !== "" && task.time !== "") {
                axios.put("api/updatetodo/" + task.id, task).then(resp => {
                    this.showEditModal = false
                    let modifiedTask = _.find(this.todos, (todo) => {return todo.id === task.id})
                    for (let prop in modifiedTask) {
                        modifiedTask[prop] = resp.data[prop]
                    }
                }).catch(er => {
                    alert("Sorry, something went wrong!")
                    console.log(er)
                })
            } else {
                alert("Please fill out the required fields")
            }
        },
        deleteTask () {
            if (confirm("Are you sure you want to delete this task?")) {
                axios.delete("api/updatetodo/" + this.taskToEdit.id).then(resp => {
                    this.showEditModal = false
                    let deletedTask = _.remove(this.todos, (todo) => {return todo.id === this.taskToEdit.id})
                }).catch(er => {
                    alert("Sorry, something went wrong!")
                    console.log(er)
                })
            } 
        },
        cancel () {
            this.showEditModal = false
        },
        openEditModal (id) {
            if (id) {
                this.taskToEdit = _.find(this.todos, (todo) => {return todo.id === id})
            } else {
                this.taskToEdit = {}
            }
            
            this.showEditModal = true
        },
    },
    created() {
        this.getTodos()
    },
}
</script>
